#pragma rtGlobals=1		// Use modern global access method.

// version 2011_05_04
// macro for extracting LEED-IV curves from darkfield LEEM imaging.

Menu "Darkfield"
"Extract_Image_from_ROI"
"Append_Contour"
"Decimate_ROI"
End

Proc Extract_Image_from_ROI()
	DF_extractImageFromROI()
end

Proc Append_Contour()
	DF_appendContour()
end

Macro Decimate_ROI()
	DF_decimate_ROI_funct()
end


Function DF_extractImageFromROI()
     	// data folder and stack
	String dfStr=SIS_getDataFolderName()
	SetDataFolder root:$(dfStr)
	String winNameStr=SIS_getWinName()
      String stackStr=SIS_getImageStackName()
      // input	
     	String zStr
     	Prompt zStr, "enter wave",popup WaveList("2*",";","")
	doPrompt "" zStr    
	if (V_flag == 0) 
		wave z=$zStr
		variable n=sqrt(dimsize(z,0))
		String dbStr=zStr+"_LE"
		make/n=(n,n)/o $dbStr=NaN
		wave dbw=$dbStr
		dbw[0,n-1][0,n-1]=z[p*n+q]
		// x and y waves
		String xStr,yStr
		Prompt xStr, "enter wave",popup WaveList("lens1*",";","")
		Prompt yStr, "enter wave",popup WaveList("lens2*",";","")
		doPrompt "enter lens1 and 2 waves" xStr,yStr    
		if (V_flag == 0) 
			String dbxStr=stackStr+"_LEX"	
			String dbyStr=stackStr+"_LEY"
			make/n=(n+1)/o $dbxStr=NaN	
			make/n=(n+1)/o $dbyStr=NaN	
			wave dbxw=$dbxStr
			wave dbyw=$dbyStr
			wave wx=$xStr
			dbxw[0,n]=wx[0]+(wx[n*n-1]-wx[0])/n*p 
			wave wy=$yStr
			dbyw[0,n]=wy[0]+(wy[n*n-1]-wy[0])/n*p  
			String graphStr="LE"+zStr
			SIS_xyImageToFront(graphStr,dbStr,dbxStr,dbyStr) 
			ModifyImage $dbStr ctab= {*,*,Grays,0}
		endif
	endif
end

Function DF_appendContour()
	String xStr,yStr,zStr
     	Prompt zStr, "enter ROI wave",popup WaveList("2*",";","")
	Prompt xStr, "enter  xwave",popup WaveList("lens2*",";","")
	Prompt yStr, "enter ywave",popup WaveList("lens1*",";","")
	doPrompt "enter contour waves" zStr,xStr,yStr
	if (V_flag == 0)         
		AppendXYZContour $zStr vs {$xStr,$yStr}
		ModifyContour $zStr labels=0
	endif
end

function DF_decimate_ROI_funct()
string nameROIstr="co"
Prompt nameROIstr, "name of destination y wave"
string  namePstr="time"
Prompt namePstr,  "name of destination x wave"
string targetROIstr
Prompt targetROIstr,"enter target Y wave",popup,WaveList("!*_P",";","WIN:")
string targetTimeStr
Prompt targetTimeStr,"enter target X wave",popup,WaveList("*_P",";","WIN:")
variable indexdf=1
Prompt indexdf, "darkfield index"
variable indexbkg=3
Prompt indexbkg, "background index"
doPrompt "input decimation", nameROIstr,namePstr,targetROIstr,targetTimeStr,indexdf, indexbkg
// if ok
if (V_flag==0)
wave ytarget=$targetROIstr
wave ptarget=$targetTimeStr
variable npt=numpnts(ytarget)-1
make/n=(npt)/o $(nameROIstr), $(namePstr)
wave roiw=$nameROIstr
wave tw=$namePstr
tw[0,npt]=ptarget[4*p+indexdf]
roiw[0,npt]=ytarget[4*p+indexdf]-ytarget[4*p+indexbkg]
appendToGraph roiw vs tw
endif
end